#!/bin/bash

inputDir="/home/sida6serv02/zentek/cosmoPaper/2dmm/AMPS/org/nc_fcst"
outputDir="/home/sida6serv02/zentek/cosmoPaper/2dmm/AMPS/fcst"
mkdir -p $outputDir
cd $outputDir
temp="/dev/shm/temp_zentek"
mkdir -p $temp

for year in $(seq 2014 2016)
do
	for month in $(seq -w 12)
	do
		echo $year $month
		for file in $(ls $inputDir/UGRD_10m/ | grep "^$year$month" )
		do
			cdo -s $(date --date="${file:0:4}-${file:4:2}-${file:6:2} + $(echo $file | sed 's/.*_f// ; s/\.nc/ hours/' )" +"-settime,%H:00:00 -setdate,%F") -sqrt -add -sqr $inputDir/UGRD_10m/$file -sqr $inputDir/VGRD_10m/${file/UGRD/VGRD} $temp/${file/UGRD/FFGRD}
			((i=i%60)); ((i++==0)) && wait
		done
		wait
		cdo -s -mergetime $temp/201*.nc $temp/mergetime.nc
		rm $temp/201*.nc
		cdo -s -remapbil,/home/sida6serv02/zentek/cosmoPaper/2dmm/C15/mean_201507.nc -setdate,$year-$month-01 -setname,FF -timmean $temp/mergetime.nc $outputDir/mean_AMPS_${year}${month}.nc
		rm $temp/mergetime.nc
	done
done

rmdir $temp

echo "DONE"

