#!/bin/bash

for RES in T15 #T15
do

inputDir="/home/sida6serv02/zentek/cosmo/COSMO_$RES"
outputDir="/data2/sida6serv02/uwm/zentek/cosmoPaper/2dmm/$RES"
mkdir -p $outputDir
cd $outputDir
mkdir -p "temp"
temp="temp"

for year in $(seq 2016 2016)
do
	for month in 06 07 08 09 10 11 12 #$(seq -w 12)
	do
		echo $year $month 
		vars="T_2M,T_2M_AV,T_S,PS,PMSL,QV_2M,ASOB_S,ATHB_S,LHFL_S,SHFL_S"
		wind=",U_10M,U_10M_AV,V_10M,V_10M_AV" # ,TD_2M,TD_2M_AV,PMSL,TOT_PREC,AEVAP_S,ATHB_S,SOBS_RAD,ASOB_S, #SHFL_S LHFL_S LWD_S SWDIR_S SWDIFD_S 
        for day in $(seq -w 1 $(cal $month $year | awk 'NF {DAYS = $NF}; END {print DAYS}'))
        do
            SELNAME=""
            for hour in $(seq -w 0 23)
            do
                SELNAME="$SELNAME -selname,$vars$wind $inputDir/$year$month$day/out02/lffd$year$month$day$hour.nc"
            done
            cdo -s -mergetime $SELNAME $temp/day_$year$month$day.nc &
        done
		wait
		bash <<-commands &
        cdo -s -mergetime $temp/day_$year$month??.nc $temp/merge_$year$month.nc
		cdo -s -merge -selname,$vars $temp/merge_$year$month.nc -expr,'FF=sqrt(U_10M*U_10M+V_10M*V_10M)' $temp/merge_$year$month.nc -expr,'FF_AV=sqrt(U_10M_AV*U_10M_AV+V_10M_AV*V_10M_AV)' $temp/merge_$year$month.nc $temp/month_$year$month.nc
		cdo -s -timmean $temp/month_$year$month.nc $outputDir/mean_$year$month.nc
        rm $temp/day_$year$month??.nc $temp/merge_$year$month.nc $temp/month_$year$month.nc
		commands
	done
done
#cdo -s -mergetime $outputDir/mean_* $outputDir/mean_all.nc
#cdo -s -mergetime $outputDir/mean_????0[4-9].nc $outputDir/mean_apr-sep.nc

done
wait
rmdir temp

echo "DONE"

