#!/bin/bash

inputDir="/data2/sida6serv02/uwm/zentek/cosmoPaper/2dmm"
outputDir="/data2/sida6serv02/uwm/zentek/cosmoPaper/2dmm/paper"
mkdir -p $outputDir
cd $outputDir

### AMPS ###
cdo -s -mergetime $inputDir/AMPS/mean_AMPS_201[4-6]??.nc $outputDir/mmAMPS.nc

### C15 ###
cdo -s -mergetime $inputDir/C15/mean_20????.nc $outputDir/mmC15.nc

### T15 ###
cdo -s -mergetime $inputDir/T15/mean_20????.nc $outputDir/mmT15.nc

### ERA ###
CHNAME="sp,PS,msl,PMSL,t2m,T_2M,d2m,TD_2M,si10,FF"
cdo -s -O -chname,$CHNAME -remapbil,$inputDir/C15/mean_201507.nc $inputDir/ERA/ERA.nc $outputDir/mmERA.nc

### ERA5 ###
cdo -s -O -chname,$CHNAME -remapbil,$inputDir/C15/mean_201507.nc $inputDir/ERA5/ERA5.nc $outputDir/mmERA5.nc

echo "DONE"

