if(Sys.info()[1]=="Windows"){ Directory = "T:/lidar" }else{ Directory = "/home/sida6serv02/zentek/lidar" }
source(paste(Directory,"/scripts/functions.R",sep=""))

par(mfrow=c(2,1))
for( PS in c("PS96") ){
  data = getVAD(PS,-20)
  uv = windVec(data$DD,data$FF)
  data$UU = uv$u
  data$VV = uv$v
  
  data2 = data.table( time = data$meta$time, 
                      longitude = round(data$meta$lon,5), 
                      latitude = round(data$meta$lat,5) )
  for( ffdd in c("ff","dd") ){
    for( i in 1:length(data$H) ){
      ### ff=u and dd=v
      data2[[paste(ffdd,data$H[i],"m",sep="")]] = data[[ list(ff="UU",dd="VV")[[ffdd]] ]] [,i]
    }
  }

  data2$time = as.POSIXct(round(data2$time,"hour"))
  final = data.table(time = unique(data2$time))
  final$lon = data2[,mean(longitude), by = time]$V1
  final$lat = data2[,mean(latitude), by = time]$V1
  for( ffdd in c("ff","dd") ){
    for( i in 1:length(data$H) ){
      final[[paste(ffdd,data$H[i],"m",sep="")]] = data2[,mean(eval(parse(text=paste(ffdd,data$H[i],"m",sep="")))), by = time]$V1
    }
  }
  final = as.data.frame(final)
  ### ff=u and dd=v
  dd = windDir( as.matrix(final[,3+1:40]) , as.matrix(final[,43+1:40]) )
  final[,3+1:40] = sqrt( as.matrix(final[,3+1:40])^2 + as.matrix(final[,43+1:40])^2 )
  final[,43+1:40] = dd
  ### ff=ff and dd=dd
  
  final = final[ apply(!is.na(as.matrix(final[,3+1:40])),1,any) ,]
  
  write.table(final,
              file = paste(Directory,"/scripts/",PS,".txt",sep=""),
              quote = FALSE, row.names = FALSE, sep = "\t"
              )

  TIME = seq(final$time[1],max(final$time),"hour")
  TIME = TIME[ ! (TIME %in% final$time) ]
  final[length(final$time)+ 1:length(TIME),1] = TIME
  final = data.table(final)
  setkey(final,time)
  final = as.data.frame(final)
  
  
  image.plot(final$time,seq(50,2000,50),as.matrix(final[,3+1:40]),zlim=c(0,25),col=tim.colors(5))
  image.plot(final$time,seq(50,2000,50),as.matrix(final[,43+1:40]),zlim=c(0,360),col=rainbow(8))
}


 