# INIT
if(0){
  library(ncdf4)
  library(data.table)
  source("T:/cosmoPaper/map/geo2rot.R")
  
  # make some more data
  h = rlon = rlat = c = list()
  for( RES in c("C05","C15") ){
    
    load(paste("T:/cosmoPaper/raso/cosmo/rdata/station",RES,".rData",sep=""))
    c[[RES]]=cosmo
    
    file = paste("S:/COSMO_",RES,"_out01/20040404/out01/lffd2004040318c.nc",sep="")
    
    nc = nc_open(file)
    land = ncvar_get(nc,"FR_LAND")
    hhl = ncvar_get(nc,"HHL")
    h[[RES]] = (hhl[,,1:60]+hhl[,,2:61])/2
    rlon[[RES]] = ncvar_get(nc,"rlon")
    rlat[[RES]] = ncvar_get(nc,"rlat")
    lon = ncvar_get(nc,"lon")
    lat = ncvar_get(nc,"lat")
    nc_close(nc)
    
  }
  
  load("T:/cosmoPaper/surface/rdata/stationFinal.rData")
  
  load("T:/lidar/rdata/shipPS96.Rdata")
  ss = geo2rot(pollon=0,pollat=12.5,polgam=180,lon=ship$lon,lat=ship$lat)
}

# plot stations numbers with PS96 # review
if(1){
  PRINT=1
  
  COL = c("firebrick1","dodgerblue","forestgreen")
  WIDTH=4
  HEIGHT=4
  #if(PRINT){ pdf(paste("T:/cosmoPaper/figures/fig01.pdf",sep=""),width=WIDTH,height=HEIGHT) }
  if(PRINT){ png(file=paste("T:/cosmoPaper/figures/fig01.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  #if(PRINT){ png(file=paste("T:/cosmoPaper/map/map.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  
  par(mfrow=c(1,1),omi=rep(0,4),mai=rep(.01,4))
  file = paste("S:/COSMO_",RES,"/20150601/out02/lffd2015053118.nc",sep="")
  #file = paste("S:/COSMO_",RES,"/20160115/out02/lffd2016011518.nc",sep="")
  nc = nc_open(file)
  ice = ncvar_get(nc,"H_ICE")
  ice[is.na(ice)] = 0
  ice[ice==0.1] = 0
  ice[ice==1] = 2
  nc_close(nc)
  
  image(rlon$C15,rlat$C15,land+ice,col=c("lightblue","grey","white"),xaxt="n",yaxt="n",asp=1,axes=FALSE)
  contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(500,5500,1000), col="gray90",labcex = 1)
  contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,1000), col="gray100",labcex = 1)
  # contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,500), col="gray60",labcex = 1)
  # contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,1000), col="gray40",labcex = 1)
  contour(rlon$C15,rlat$C15,lon,add=TRUE,levels = seq(-180,180,45), col="gray30",labcex = 1,vfont=c("sans serif", "italic"))
  contour(rlon$C15,rlat$C15,lat,add=TRUE,levels = seq(-180,180,10), col="gray30",labcex = 1,method="edge",vfont=c("sans serif", "italic"))
  
  shift = 0.12
  rect( min(rlon$C05)+shift,min(rlat$C05)+shift , max(rlon$C05)-shift,max(rlat$C05)-shift ,lwd=3, lty=2 ,border=COL[1] )
  text(rlon$C15[155],rlat$C15[188],"C05",cex=2,col=COL[1],font=2)
  text(rlon$C15[155],rlat$C15[168],"(500x400)",cex=1,col=COL[1],font=2)
  rect( min(rlon$C15)+shift,min(rlat$C15)+shift , max(rlon$C15)-shift,max(rlat$C15)-shift ,lwd=3, lty=2 ,border=COL[2] ,xpd=FALSE)
  text(rlon$C15[125],rlat$C15[285],"C15",cex=2,col=COL[2],font=2)
  text(rlon$C15[175],rlat$C15[285],"/T15",cex=2,col=COL[3],font=2)
  text(rlon$C15[150],rlat$C15[265],"(300x300)",cex=1,col=COL[2],font=2)
  
  ### PS96
  index = as.POSIXct("2016/01/17 00:00",tz="UTC") < ship$time & ship$time < as.POSIXct("2016/01/18 00:00",tz="UTC")
  # lines(ss$x[index],ss$y[index],col="purple",lwd=3)
  text(mean(ss$x[index])-.8,mean(ss$y[index])+1,"A",col="purple",font=2,cex=1.5)
  # 
  # index = as.POSIXct("2015/12/31 12:00",tz="UTC") < ship$time & ship$time < as.POSIXct("2016/01/02 12:00",tz="UTC")
  # # lines(ss$x[index],ss$y[index],col="purple",lwd=3)
  # text(mean(ss$x[index])-1.2,mean(ss$y[index])+0,"B",col="purple",font=2,cex=1.5)
  # #
  index = as.POSIXct("2016/01/20 00:00",tz="UTC") < ship$time & ship$time < as.POSIXct("2016/01/31 00:00",tz="UTC")
  # lines(ss$x[index],ss$y[index],col="purple",lwd=3)
  text(mean(ss$x[index])-.5,mean(ss$y[index])+2,"B",col="purple",font=2,cex=1.5)
  
  
  # xoff = c(-30,-25,-5,-25,-20,-10)
  # yoff = c(20,10,20,10,-20,-20)
  # Amundsen-Scott,Halley,MarambioNeumayer,Novolazarevskaya,Rothera  
  xoff = c(-60,28,33,-10,-45,-8)
  yoff = c(-10,0,10,15,-13,-13)
  for( is in (1:length(cosmo$meta$name)) ){
    points(rlon$C15[cosmo$meta$ix[is]],rlat$C15[cosmo$meta$iy[is]],cex=2.5,pch=5)
    text(rlon$C15[cosmo$meta$ix[is]+xoff[is]],rlat$C15[cosmo$meta$iy[is]+yoff[is]],cosmo$meta$name[is],cex=.9,font=2)
  }
  
  # south # east coast # south Peninsula # middle peninsula # north peninsula
  chosen = c(5,12 , 47,65,107 , 33,45,30 , 41,43,50,53 , 76,78,81,83,87,89)
  color  = 1+c(1,1  ,  2, 2,  2 ,  3, 3, 3 ,  4, 4, 4, 4 ,  5, 5, 5, 5, 5, 5)
  color  = 1
  xoff = c(rep(0,8)                      ,  0,1.5,0,0 ,  0,-3,-3,-3,-.5,-3)
  yoff = c(rep(0,8)                      ,  0,0.8,0,0 ,  0,-2.5,-1,0.5,2,+2)
  textxoff = xoff - c(rep(0,8)           ,  0,0.6,0,0 ,  0,-0.9,-0.9,-0.9,0,-0.9)
  textyoff = yoff - c(rep(0,8)           ,  0,0.1,0,0 ,  0,0,0,0,0.5,0)
  if(1){
    
    ### map ###
    #image(rlon,rlat,land,col=c("cornflowerblue","gray"),asp=1,xaxt="n",yaxt="n")
    #points(station$meta$rlon,station$meta$rlat,pch=20)
    index = station$meta$source[chosen]=="bas_surface"
    #points(station$meta$rlon[chosen][index],station$meta$rlat[chosen][index],pch=1,lwd=2,cex=2,col="black") #19/21/1
    #points(station$meta$rlon[chosen][!index],station$meta$rlat[chosen][!index],pch=2,lwd=2,cex=2,col="black") #17/24/2
    text(station$meta$rlon[chosen]+xoff,station$meta$rlat[chosen]+yoff,label=seq(chosen),cex=1,col=color,font=2)
    for( i in which(xoff!=0|yoff!=0)){
      lines(station$meta$rlon[chosen][i]+c(0,textxoff[i]),station$meta$rlat[chosen][i]+c(0,textyoff[i]))
      #points(station$meta$rlon[chosen][i],station$meta$rlat[chosen][i],pch=20,cex=0.5)
    }
    
  }
  
  if(PRINT) dev.off()
}

# plot stations with PS96
if(0){
  PRINT=1
  
  COL = c("firebrick1","dodgerblue","forestgreen")
  WIDTH=4
  HEIGHT=4
  #if(PRINT){ pdf(paste("T:/cosmoPaper/figures/fig01.pdf",sep=""),width=WIDTH,height=HEIGHT) }
  if(PRINT){ png(file=paste("T:/cosmoPaper/figures/fig01.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  #if(PRINT){ png(file=paste("T:/cosmoPaper/map/map.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  
  par(mfrow=c(1,1),omi=rep(0,4),mai=rep(.01,4))
    file = paste("S:/COSMO_",RES,"/20150601/out02/lffd2015053118.nc",sep="")
    #file = paste("S:/COSMO_",RES,"/20160115/out02/lffd2016011518.nc",sep="")
    nc = nc_open(file)
    ice = ncvar_get(nc,"H_ICE")
    ice[is.na(ice)] = 0
    ice[ice==0.1] = 0
    ice[ice==1] = 2
    nc_close(nc)
    
  image(rlon$C15,rlat$C15,land+ice,col=c("lightblue","grey","white"),xaxt="n",yaxt="n",asp=1,axes=FALSE)
  contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(500,5500,1000), col="gray90",labcex = 1)
  contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,1000), col="gray100",labcex = 1)
  # contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,500), col="gray60",labcex = 1)
  # contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,1000), col="gray40",labcex = 1)
  contour(rlon$C15,rlat$C15,lon,add=TRUE,levels = seq(-180,180,45), col="gray30",labcex = 1,vfont=c("sans serif", "italic"))
  contour(rlon$C15,rlat$C15,lat,add=TRUE,levels = seq(-180,180,10), col="gray30",labcex = 1,method="edge",vfont=c("sans serif", "italic"))
  
  shift = 0.12
  rect( min(rlon$C05)+shift,min(rlat$C05)+shift , max(rlon$C05)-shift,max(rlat$C05)-shift ,lwd=3, lty=2 ,border=COL[1] )
  text(rlon$C15[155],rlat$C15[188],"C05",cex=2,col=COL[1],font=2)
  text(rlon$C15[155],rlat$C15[168],"(500x400)",cex=1,col=COL[1],font=2)
  rect( min(rlon$C15)+shift,min(rlat$C15)+shift , max(rlon$C15)-shift,max(rlat$C15)-shift ,lwd=3, lty=2 ,border=COL[2] ,xpd=FALSE)
  text(rlon$C15[125],rlat$C15[285],"C15",cex=2,col=COL[2],font=2)
  text(rlon$C15[175],rlat$C15[285],"/T15",cex=2,col=COL[3],font=2)
  text(rlon$C15[150],rlat$C15[265],"(300x300)",cex=1,col=COL[2],font=2)

  ### PS96
  index = as.POSIXct("2016/01/17 00:00",tz="UTC") < ship$time & ship$time < as.POSIXct("2016/01/18 00:00",tz="UTC")
  # lines(ss$x[index],ss$y[index],col="purple",lwd=3)
  text(mean(ss$x[index])-.8,mean(ss$y[index])+1,"A",col="purple",font=2,cex=1.5)
  # 
  # index = as.POSIXct("2015/12/31 12:00",tz="UTC") < ship$time & ship$time < as.POSIXct("2016/01/02 12:00",tz="UTC")
  # # lines(ss$x[index],ss$y[index],col="purple",lwd=3)
  # text(mean(ss$x[index])-1.2,mean(ss$y[index])+0,"B",col="purple",font=2,cex=1.5)
  # #
  index = as.POSIXct("2016/01/20 00:00",tz="UTC") < ship$time & ship$time < as.POSIXct("2016/01/31 00:00",tz="UTC")
  # lines(ss$x[index],ss$y[index],col="purple",lwd=3)
  text(mean(ss$x[index])-.5,mean(ss$y[index])+2,"B",col="purple",font=2,cex=1.5)
  
	
  # xoff = c(-30,-25,-5,-25,-20,-10)
  # yoff = c(20,10,20,10,-20,-20)
  xoff = c(-60,25,10,-10,-45,-8)
  yoff = c(-10,0,15,15,-13,-10)
  for( is in (1:length(cosmo$meta$name)) ){
    points(rlon$C15[cosmo$meta$ix[is]],rlat$C15[cosmo$meta$iy[is]],cex=2,pch=15)
    text(rlon$C15[cosmo$meta$ix[is]+xoff[is]],rlat$C15[cosmo$meta$iy[is]+yoff[is]],cosmo$meta$name[is],cex=.9,font=2)
  }
  
  chosen = c(5,12 , 47,65,107 , 34,45,32 , 41,43,50,52 , 76,78,81,83,87,89)
  color  = 1+c(1,1  ,  2, 2,  2 ,  3, 3, 3 ,  4, 4, 4, 4 ,  5, 5, 5, 5, 5, 5)
  xoff = c(rep(0,8)                      ,  -.5,.5,0,0 ,  0,-1,-1,-1,0,-1)
  yoff = c(rep(0.5,12)                                 ,  0.5,-2,-1,0,1,+1)
  if(1){
    
    ### map ###
    #image(rlon,rlat,land,col=c("cornflowerblue","gray"),asp=1,xaxt="n",yaxt="n")
    #points(station$meta$rlon,station$meta$rlat,pch=20)
    index = station$meta$source[chosen]=="bas_surface"
    points(station$meta$rlon[chosen][index],station$meta$rlat[chosen][index],pch=1,lwd=2,cex=2,col="black") #19/21/1
    points(station$meta$rlon[chosen][!index],station$meta$rlat[chosen][!index],pch=2,lwd=2,cex=2,col="black") #17/24/2
    #text(station$meta$rlon[chosen]+xoff,station$meta$rlat[chosen]+yoff,label=chosen,cex=1,col=color,font=2)
    
  }
  
  if(PRINT) dev.off()
}

