if(1){
  library(ncdf4)
  library(data.table)
  source("/home/sida6serv02/zentek/R/ncdf4Utils_1.0/R/geo2rot.R")
  source("/home/sida6serv02/zentek/R/rotateWind.R")
  
  inpath="/home/sida6serv02/zentek/cosmoPaper/raso"
  outpath="/home/sida6serv02/zentek/cosmoPaper/raso/rdata"
  
  # META DATA
  meta = data.table(
    name = c("Amundsen-Scott","Halley","Marambio","Neumayer","Novolazarevskaya","Rothera"),
    lon = c(   0, -26.660, -56.633,  -8.274,  11.832, -68.133),
    lat = c( -90, -75.583, -64.233, -70.674, -70.768, -67.566),
    height = c( 2835, 30, 198, 50, 119, 16),
    ix = numeric(6), iy = numeric(6))
  
  load(paste(inpath,"wyoming/rdata/stations.rData",sep="/"))
  w = stations
  ###### check for error ######
  # for( i in 1:length(stations) ){
  #   if( meta$name[i]!=stations[[i]]$name ){
  #     print(c("error name",stations[[i]]$name,meta$name[i]))
  #   }
  #   if( length(unique(stations[[i]]$meta[[3]]))==1 ){
  #     if( meta$height[i]!=unique(stations[[i]]$meta$elevation) ){
  #       print(c("error height",meta$name[i],meta$sheight[i]))
  #     }
  #     if( round(meta$lon[i],1)!=round(unique(stations[[i]]$meta$lon),1) ){
  #       print(c("error lon ",meta$name[i],meta$lon[i],unique(stations[[i]]$meta$lon)))
  #     }
  #     if( round(meta$lat[i],1)!=round(unique(stations[[i]]$meta$lat),1) ){
  #       print(c("error lat ",meta$name[i],meta$lon[i],unique(stations[[i]]$meta$lat)))
  #     }
  #   }else{
  #     print(c("error unique",stations[[i]]$name,meta$name[i]))
  #   }
  # }
  
  pref = h = lon = lat = c = list()
  for( RES in c("C15","C05","C1518","C0518","T15")[] ){
    
    load(paste(inpath,"/cosmo/rdata/station",RES,".rData",sep=""))
    c[[RES]]=cosmo
    
    xRES=RES
    if(RES=="C1518"){xRES="C15"}
    if(RES=="T15"){xRES="C15"}
    if(RES=="C0518"){xRES="C05"}
    file = paste("/home/sida6serv02/zentek/cosmo/COSMO_",xRES,"_out01/20150404/out01/lffd2015040318c.nc",sep="")
    
    nc = nc_open(file)
    land = ncvar_get(nc,"FR_LAND")
    hhl = ncvar_get(nc,"HHL")
    h[[RES]] = (hhl[,,1:60]+hhl[,,2:61])/2
    vcoord = ncvar_get(nc,"vcoord")
    p0sl = ncatt_get(nc,"vcoord","p0sl")$value
    t0sl = ncatt_get(nc,"vcoord","t0sl")$value
    dt0lp = ncatt_get(nc,"vcoord","dt0lp")$value
    delta_t = ncatt_get(nc,"vcoord","delta_t")$value
    h_scal = ncatt_get(nc,"vcoord","h_scal")$value
    g = 9.80665#9.807
    R = 287.05
    t00 = t0sl - delta_t
    # pref = p0sl * exp( -g*h_scal/ R/t00 * log( (exp(vcoord/h_scal)*t00 + delta_t)/(t00 + delta_t)) )
    pref[[RES]] = p0sl * exp( -g*h_scal/ R/t00 * log( (exp(h[[RES]]/h_scal)*t00 + delta_t)/(t00 + delta_t)) )
    lon[[RES]] = ncvar_get(nc,"lon")
    lat[[RES]] = ncvar_get(nc,"lat")
    nc_close(nc)
  }
  
}

#### MAIN PROGRAM ###
station = list(meta=meta,data=list())
for( is in 1:length(w) ){
  print(meta[is])
  time = w[[is]]$meta$time
  N = length(time)
  H = seq(1000,50,-25)
  
  ### interpolate raso data to cosmo heights ###
  T = Q = P = U = V = FF = DD = G = matrix(NA, nrow=length(time), ncol=length(H))
  TESTH = h[["C15"]] [c[["C15"]]$meta$ix[is],c[["C15"]]$meta$iy[is],]
  TESTP = matrix(NA, nrow=length(time), ncol=length(TESTH))
  toDelete = NULL
  for( it in 1:length(time) ){      
    oldH = w[[is]]$data[[it]]$p
    #### wos = WithOutSurface
    #w[[is]]$data[[it]] [  which(w[[is]]$data[[it]]$h==meta$height[is]) ,3:10  ] = NA
    ####
    res = tryCatch(
      {
        alpha = ((w[[is]]$data[[it]]$dd+180)%%360)/180*pi
        u = sin(alpha) * w[[is]]$data[[it]]$ff
        v = cos(alpha) * w[[is]]$data[[it]]$ff
        U[it,] = approx(oldH, u ,H)$y
        V[it,] = approx(oldH, v ,H)$y
        DD[it,] = (atan2(U[it,],V[it,])*180/pi + 180)%%360
        FF[it,] = sqrt(U[it,]^2+V[it,]^2)
        Q[it,] = approx(oldH, w[[is]]$data[[it]]$mr/1000 ,H)$y
        P[it,] = approx(oldH, w[[is]]$data[[it]]$p ,H)$y
        T[it,] = approx(oldH, w[[is]]$data[[it]]$t ,H)$y
        G[it,] = approx(oldH, w[[is]]$data[[it]]$h ,H)$y
        TESTP[it,] = approx(w[[is]]$data[[it]]$h, w[[is]]$data[[it]]$p ,TESTH)$y
      }
      , error=function(e){} )
    if(is.null(res)){
      toDelete = c(toDelete,it)
    }

  }# time
  print(paste("removed ",length(toDelete),"/",length(time),"rasos (NA column found)"))
  W = list(h=H,t=T[-toDelete,],q=Q[-toDelete,],p=P[-toDelete,],u=U[-toDelete,],v=V[-toDelete,],ff=FF[-toDelete,],dd=DD[-toDelete,],g=G[-toDelete,])
  time = time[-toDelete]
  TESTP = TESTP[-toDelete,]
  HHH = 1:length(TESTH)
  SD = apply(TESTP,2,sd,na.rm = TRUE)
  MEAN = apply(TESTP,2,mean,na.rm = TRUE)
  INSIDE = apply(TESTP,1,function(x){all(MEAN[HHH]-3*SD[HHH]<x[HHH]&x[HHH]<MEAN[HHH]+3*SD[HHH],na.rm = TRUE)})
  W = list(h=H,t=W$t[INSIDE,],q=W$q[INSIDE,],p=W$p[INSIDE,],u=W$u[INSIDE,],v=W$v[INSIDE,],ff=W$ff[INSIDE,],dd=W$dd[INSIDE,],g=W$g[INSIDE,])
  time = time[INSIDE]
  print(paste("removed ",length(which(!INSIDE)),"/",length(INSIDE),"rasos (p > 3*sigma)"))
  
  for( RES in c("C15","C05","C1518","C0518","T15") ){
    T = Q = P = U = V = FF = DD = G = matrix(NA, nrow=length(time), ncol=length(H))
    for( it in 1:length(time) ){      
      index = which(time[it]==c[[RES]]$time[[is]])
      if(length(index)==1){
        data = c[[RES]]$data[[is]] [[ index ]]
        if(meta$name[is]=="Amundsen-Scott"){
          u = data$u
          v = data$v
          dd = (atan2(data$u,data$v)*180/pi + 180)%%360
          dd = sqrt(data$u^2+data$v^2)
        }else{
          geoWind = uvrot2geo(data$u,data$v, lon[[RES]] [c[[RES]]$meta$ix[is],c[[RES]]$meta$iy[is]] , lat[[RES]] [c[[RES]]$meta$ix[is],c[[RES]]$meta$iy[is]])
          u = geoWind$u
          v = geoWind$v
          dd = (atan2(geoWind$u,geoWind$v)*180/pi + 180)%%360
          ff = sqrt(geoWind$u^2+geoWind$v^2)
        }
        q = data$qv
        # e = p * q / (0.622+0.378*q)
        # es = 6.112 * exp(17.62*(t-273.15)/(243.12+t-273.15))
        # rh = e/es
        # d = log(e/6.11) * 243.04 / (17.625 - log(e/6.11) )
        p = (data$pp + pref[[RES]] [c[[RES]]$meta$ix[is],c[[RES]]$meta$iy[is],])/100
        t = data$t - 273.15
        
        oldH = p
        U[it,] = approx(oldH, u ,H)$y
        V[it,] = approx(oldH, v ,H)$y
        DD[it,] = (atan2(U[it,],V[it,])*180/pi + 180)%%360
        FF[it,] = sqrt(U[it,]^2+V[it,]^2)
        Q[it,] = approx(oldH, q ,H)$y
        P[it,] = approx(oldH, p ,H)$y
        T[it,] = approx(oldH, t ,H)$y
        G[it,] = approx(oldH, h[[RES]] [c[[RES]]$meta$ix[is],c[[RES]]$meta$iy[is],] ,H)$y
      }else{
        U[it,] = V[it,] = DD[it,] = FF[it,] = Q[it,] = P[it,] = T[it,] = G[it,] = NA
      }
    }# time
    if(RES=="C05"){ C05 = list(meta=c[[RES]]$meta,h=H,t=T,q=Q,p=P,u=U,v=V,ff=FF,dd=DD,g=G) }
    if(RES=="C15"){ C15 = list(meta=c[[RES]]$meta,h=H,t=T,q=Q,p=P,u=U,v=V,ff=FF,dd=DD,g=G) }
    if(RES=="C0518"){ C0518 = list(meta=c[[RES]]$meta,h=H,t=T,q=Q,p=P,u=U,v=V,ff=FF,dd=DD,g=G) }
    if(RES=="C1518"){ C1518 = list(meta=c[[RES]]$meta,h=H,t=T,q=Q,p=P,u=U,v=V,ff=FF,dd=DD,g=G) }
    if(RES=="T15"){ T15 = list(meta=c[[RES]]$meta,h=H,t=T,q=Q,p=P,u=U,v=V,ff=FF,dd=DD,g=G) }
  }# RES
  
  station$data[[is]] = list(time=time,w=W,C05=C05,C15=C15,C0518=C0518,C1518=C1518,T15=T15)  
  
  
}# is

outpath="/home/sida6serv02/zentek/cosmoPaper/raso/rdata"
save(station,file=paste(outpath,"stationsP.rData",sep="/"))
