#!/bin/bash

outpath="/home/sida6serv02/zentek/cosmoPaper/raso/wyoming/org"
mkdir -p $outpath

STATIONNAME=([1]="Halley" [2]="Neumayer" [3]="Rothera" [4]="Novolazarevskaya" [5]="Amundsen-Scott" [6]="Marambio")
STATIONNUMBER=([1]="89022" [2]="89002" [3]="89062" [4]="89512" [5]="89009" [6]="89055")

for station in $(seq ${#STATIONNUMBER[@]})
do
	for year in $(seq 2016 2016)
	do
		for month in $(seq -w 1 12)
		do
			lastDay="$(cal $month $year | awk 'NF {DAYS = $NF}; END {print DAYS}')"
			wget -O $outpath/${STATIONNAME[station]}_$year$month.txt "http://weather.uwyo.edu/cgi-bin/sounding?region=ant&TYPE=TEXT%3ALIST&YEAR=${year}&MONTH=${month}&FROM=0100&TO=${lastDay}12&STNM=${STATIONNUMBER[station]}" &
		done
		wait
	done
done
