library(data.table)
library(ncdf4)
source("T:/cosmoPaper/map/geo2rot.R")
source("T:/cosmoPaper/map/rotateWind.R")

# SAVE
if(0){
  file = dir("T:/cosmoPaper/seaice",full.names = TRUE)
  file = file[grep(".csv",file)]
  aws = list()
  for( i in seq(file) ){
    aws[[i]] = unique(data.table(read.csv(file[i],stringsAsFactors = FALSE)))
    aws[[i]]$time = as.POSIXct(aws[[i]]$DateTime,"%Y-%m-%dT%H:%M:%S",tz="UTC")
    out = geo2rot(0,12.5,aws[[i]]$Longitude,aws[[i]]$Latitude,180)
    aws[[i]]$rlon = (out$x)
    aws[[i]]$rlat = (out$y)
    print(length(which(duplicated(data.table(read.csv(file[i],stringsAsFactors = FALSE))))))
  }
  save(aws,file="T:/cosmoPaper/seaice/aws.Rdata")
} # aws
if(0){
  cclm = list()
  XLIM = as.POSIXct(c("2016-01-15","2017-03-02"),tz="UTC")
  XLIM = as.POSIXct(c("2016-01-15","2016-12-31"),tz="UTC")
  TIME = seq(XLIM[1],XLIM[2],"hour")
  for( i in seq(aws) ){ cclm[[i]]=data.table(time=TIME,t2m=NA,ff=NA,dd=NA) }
  
  RES = "C15"
  nc <- nc_open(paste("S:/COSMO_",RES,"/20160110/out02/lffd2016011000.nc",sep=""))
  crlon <- ncvar_get(nc,"rlon")
  crlat <- ncvar_get(nc,"rlat")
  nc_close(nc)
  for( it in 1:length(TIME) ){
    print(TIME[it])
    nc = nc_open(paste("S:/COSMO_",RES,strftime(TIME[it],"/%Y%m%d/out02/lffd%Y%m%d%H.nc",tz="UTC"),sep=""))
    for( i in seq(aws) ){
      tindex = which( aws[[i]]$time == TIME[it] )
      if(length(tindex==1)){
        cx = which.min(abs(mean(aws[[i]]$rlon[tindex])-crlon))
        cy = which.min(abs(mean(aws[[i]]$rlat[tindex])-crlat))
        cclm[[i]]$t2m[it] = ncvar_get(nc,"T_2M",start=c(cx,cy,1),count=c(1,1,1))-273.15
        u = ncvar_get(nc,"U_10M",start=c(cx,cy,1),count=c(1,1,1))
        v = ncvar_get(nc,"V_10M",start=c(cx,cy,1),count=c(1,1,1))
        lon = ncvar_get(nc,"lon",start=c(cx,cy),count=c(1,1))
        lat = ncvar_get(nc,"lat",start=c(cx,cy),count=c(1,1))
        geo = uvrot2geo(u,v,lon,lat)
        cclm[[i]]$ff[it] = sqrt( u^2 + v^2 )
        cclm[[i]]$dd[it] = (atan2(geo$u,geo$v)*180/pi + 180)%%360 
      }
    }
    nc_close(nc)
  }
  save(cclm,file="T:/cosmoPaper/seaice/cclm.Rdata")
} # C15
if(0){
  tclm = list()
  XLIM = as.POSIXct(c("2016-01-15","2017-03-02"),tz="UTC")
  XLIM = as.POSIXct(c("2016-01-15","2016-12-31"),tz="UTC")
  TIME = seq(XLIM[1],XLIM[2],"hour")
  for( i in seq(aws) ){ tclm[[i]]=data.table(time=TIME,t2m=NA,ff=NA,dd=NA) }
  
  RES = "T15"
  nc <- nc_open(paste("R:/COSMO_",RES,"/20160110/out02/lffd2016011000.nc",sep=""))
  crlon <- ncvar_get(nc,"rlon")
  crlat <- ncvar_get(nc,"rlat")
  nc_close(nc)
  for( it in 1:length(TIME) ){
    print(TIME[it])
    nc = nc_open(paste("R:/COSMO_",RES,strftime(TIME[it],"/%Y%m%d/out02/lffd%Y%m%d%H.nc",tz="UTC"),sep=""))
    for( i in seq(aws) ){
      tindex = which( aws[[i]]$time == TIME[it] )
      if(length(tindex==1)){
        cx = which.min(abs(mean(aws[[i]]$rlon[tindex])-crlon))
        cy = which.min(abs(mean(aws[[i]]$rlat[tindex])-crlat))
        tclm[[i]]$t2m[it] = ncvar_get(nc,"T_2M",start=c(cx,cy,1),count=c(1,1,1))-273.15
        u = ncvar_get(nc,"U_10M",start=c(cx,cy,1),count=c(1,1,1))
        v = ncvar_get(nc,"V_10M",start=c(cx,cy,1),count=c(1,1,1))
        lon = ncvar_get(nc,"lon",start=c(cx,cy),count=c(1,1))
        lat = ncvar_get(nc,"lat",start=c(cx,cy),count=c(1,1))
        geo = uvrot2geo(u,v,lon,lat)
        tclm[[i]]$ff[it] = sqrt( u^2 + v^2 )
        tclm[[i]]$dd[it] = (atan2(geo$u,geo$v)*180/pi + 180)%%360 
      }
    }
    nc_close(nc)
  }
  save(tclm,file="T:/cosmoPaper/seaice/tclm.Rdata")
} # T15
if(0){
  cclm = list()
  XLIM = as.POSIXct(c("2016-01-15","2017-03-02"),tz="UTC")
  XLIM = as.POSIXct(c("2016-01-15","2016-09-30"),tz="UTC")
  TIME = seq(XLIM[1],XLIM[2],"hour")
  for( i in seq(aws) ){ cclm[[i]]=data.table(time=TIME,t2m=NA,ff=NA,dd=NA) }
  
  RES = "C05"
  nc <- nc_open(paste("S:/COSMO_",RES,"/20160110/out02/lffd2016011000.nc",sep=""))
  crlon <- ncvar_get(nc,"rlon")
  crlat <- ncvar_get(nc,"rlat")
  nc_close(nc)
  for( it in 1:length(TIME) ){
    print(TIME[it])
    nc = nc_open(paste("S:/COSMO_",RES,strftime(TIME[it],"/%Y%m%d/out02/lffd%Y%m%d%H.nc",tz="UTC"),sep=""))
    for( i in seq(aws) ){
      tindex = which( aws[[i]]$time == TIME[it] )
      if(length(tindex==1)){
        cx = which.min(abs(mean(aws[[i]]$rlon[tindex])-crlon))
        cy = which.min(abs(mean(aws[[i]]$rlat[tindex])-crlat))
        cclm[[i]]$t2m[it] = ncvar_get(nc,"T_2M",start=c(cx,cy,1),count=c(1,1,1))-273.15
        u = ncvar_get(nc,"U_10M",start=c(cx,cy,1),count=c(1,1,1))
        v = ncvar_get(nc,"V_10M",start=c(cx,cy,1),count=c(1,1,1))
        lon = ncvar_get(nc,"lon",start=c(cx,cy),count=c(1,1))
        lat = ncvar_get(nc,"lat",start=c(cx,cy),count=c(1,1))
        geo = uvrot2geo(u,v,lon,lat)
        cclm[[i]]$ff[it] = sqrt( u^2 + v^2 )
        cclm[[i]]$dd[it] = (atan2(geo$u,geo$v)*180/pi + 180)%%360 
      }
    }
    nc_close(nc)
  }
  cclm5=cclm
  save(cclm5,file="T:/cosmoPaper/seaice/cclm5.Rdata")
} # C05


XLIM = as.POSIXct(c("2016-01-01","2016-12-31"),tz="UTC")
load("T:/cosmoPaper/seaice/aws.Rdata")
## check which outliers are removed
if(0){
  par(mfrow=c(3,2))
  for( ia in seq(aws) ){
    for( var in c("Longitude","Latitude") ){
      remove = which( abs(diff(aws[[ia]][[var]])) > 1)
      plot(aws[[ia]]$time,aws[[ia]][[var]])
      points(aws[[ia]]$time[remove],aws[[ia]][[var]][remove],col=2,pch=3,cex=3)
      if(length(remove)>0) text(aws[[ia]]$time[remove],aws[[ia]][[var]][remove],labels = remove,col=3,font=2,cex=2)
      print(c(ia,"removing",remove))
      #aws[[ia]][-remove]
    }
  }
}
aws[[2]] = aws[[2]][-c(7102)]
aws[[3]] = aws[[3]][-c(5876,5877,6547)]
aws[[3]] = aws[[3]][ aws[[3]]$time<as.POSIXct(c("2016-12-15"),tz="UTC")] # 31
for( ia in seq(aws) ){
  aws[[ia]]$t2m = aws[[ia]]$TAir
  aws[[ia]]$ff = aws[[ia]]$WindSp
  aws[[ia]]$dd = (aws[[ia]]$RelWndDir + aws[[ia]]$Compass)%%360
}
load("T:/cosmoPaper/seaice/cclm.Rdata")
for( ia in seq(cclm) ){ cclm[[ia]]$ff = cclm[[ia]]$ff* 0.825 }
load("T:/cosmoPaper/seaice/tclm.Rdata")
for( ia in seq(tclm) ){ tclm[[ia]]$ff = tclm[[ia]]$ff* 0.825 }
load("T:/cosmoPaper/seaice/cclm5.Rdata")
for( ia in seq(cclm5) ){ cclm5[[ia]]$ff = cclm5[[ia]]$ff* 0.825 }
data = list(aws=aws,C15=cclm,T15=tclm,C05=cclm5)

### make mean data
# returns horizontal wind vector
windVec = function(dd,ff=1){
  alpha = ((dd+180)%%360)/180*pi
  u = sin(alpha) * ff
  v = cos(alpha) * ff
  return(V=list(u=u,v=v))
}
# returns DD
windDir = function(u, v){ 
  return( (atan2(u,v)*180/pi + 180)%%360 )
}
mdata=data
for(i in seq(data)){
  for( j in 1:3){
    uv = windVec(data[[i]][[j]]$dd,data[[i]][[j]]$ff)
    data[[i]][[j]]$u = uv$u
    data[[i]][[j]]$v = uv$v
    data[[i]][[j]]$week = as.numeric(strftime(data[[i]][[j]]$time,"%W",tz="UTC"))
    u = data[[i]][[j]][,mean(u,na.rm=TRUE), by = week]$V1
    v = data[[i]][[j]][,mean(v,na.rm=TRUE), by = week]$V1
    mdata[[i]][[j]] = data.table(
      time = data[[i]][[j]][,mean(time,na.rm=TRUE), by = week]$V1,
      t2m = data[[i]][[j]][,mean(t2m,na.rm=TRUE), by = week]$V1,
      ff = sqrt(u^2+v^2),
      dd = windDir(u,v)
    )
  }
}

# par(mfrow=c(2,2))
# for( i in seq(aws) ){
#   COL = rainbow(12)[ as.numeric(strftime(aws[[i]]$DateTime,"%m")) ]
#   plot(aws[[i]]$Longitude,aws[[i]]$Latitude,col=COL,xlim=c(-80,-20),ylim=c(-76,-66))
# }

# map
if(0){
  #INIT
  if(0){
    # make some more data
    h = rlon = rlat = c = list()
    for( RES in c("C15","C05") ){
      
      load(paste("T:/cosmoPaper/raso/cosmo/rdata/station",RES,".rData",sep=""))
      c[[RES]]=cosmo
      
      file = paste("S:/COSMO_",RES,"_out01/20040404/out01/lffd2004040318c.nc",sep="")
      
      nc = nc_open(file)
      land = ncvar_get(nc,"FR_LAND")
      hhl = ncvar_get(nc,"HHL")
      h[[RES]] = (hhl[,,1:60]+hhl[,,2:61])/2
      rlon[[RES]] = ncvar_get(nc,"rlon")
      rlat[[RES]] = ncvar_get(nc,"rlat")
      lon = ncvar_get(nc,"lon")
      lat = ncvar_get(nc,"lat")
      nc_close(nc)
      
    }
    file = paste("S:/COSMO_",RES,"/20150601/out02/lffd2015053118.nc",sep="")
    nc = nc_open(file)
    ice = ncvar_get(nc,"H_ICE")
    ice[is.na(ice)] = 0
    ice[ice==0.1] = 0
    ice[ice==1] = 2
    nc_close(nc)
  }
  PRINT=1
  
  COL = c("firebrick1","dodgerblue","forestgreen")
  WIDTH=5
  HEIGHT=4
  #if(PRINT){ pdf(paste("T:/cosmoPaper/figures/fig02.pdf",sep=""),width=WIDTH,height=HEIGHT) }
  if(PRINT){ png(file=paste("T:/cosmoPaper/figures/fig02.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  #if(PRINT){ png(file=paste("T:/cosmoPaper/seaice/paper/map_aws.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  
  par(mfrow=c(1,1),omi=rep(0,4),mai=rep(.01,4))
  COL = c("firebrick1","dodgerblue","forestgreen")
  image(rlon$C05,rlat$C05,land+ice,col=c("lightblue","grey","white"),xaxt="n",yaxt="n",asp=1)
  contour(rlon$C05,rlat$C05,hhl[,,60],add=TRUE,levels = seq(500,5500,1000), col="gray90",labcex = 1)
  contour(rlon$C05,rlat$C05,hhl[,,60],add=TRUE,levels = seq(0,5000,1000), col="gray100",labcex = 1)
  # contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,500), col="gray60",labcex = 1)
  # contour(rlon$C15,rlat$C15,hhl[,,60],add=TRUE,levels = seq(0,5000,1000), col="gray40",labcex = 1)
  contour(rlon$C05,rlat$C05,lon,add=TRUE,levels = seq(-180,180,45), col="gray30",labcex = 1,vfont=c("sans serif", "italic"))
  contour(rlon$C05,rlat$C05,lat,add=TRUE,levels = seq(-180,180,10), col="gray30",labcex = 1,vfont=c("sans serif", "italic"))
  shift = 0.05
  rect( min(rlon$C05)+shift,min(rlat$C05)+shift , max(rlon$C05)-shift,max(rlat$C05)-shift ,lwd=3, lty=2 ,border=COL[1] )
  text(rlon$C05[450],rlat$C05[370],"C05",cex=2,col=COL[1],font=2)
  
  for( ia in seq(aws) ){
    TLIM = as.POSIXct(c("2016/01/01","2017/01/01"),tz="UTC")
    TIME = seq(TLIM[1],TLIM[2],"month")
    LWD = 15
    COL = c(colorRampPalette(c("orange","yellow"))(3),
            colorRampPalette(c("red","blue"))(6),
            colorRampPalette(c("green","black"))(3))
    for( it in 2:length(TIME)  ){
      index = TIME[it-1] <= aws[[ia]]$time & aws[[ia]]$time < TIME[it]
      lines(aws[[ia]]$rlon[index],aws[[ia]]$rlat[index],col=COL[it],lwd=LWD)
    }
    xoff = c(-.3,+3.3,+1.8)
    yoff = c(-3,-.2,+5)
    text(median(aws[[ia]]$rlon)+xoff[ia],median(aws[[ia]]$rlat)+yoff[ia],labels=paste("AWS",ia),font=2,cex=2)
  }
  
  legend("bottomleft",title="2016",legend=month.abb,col=COL,lwd=LWD,cex=1.2)
  if(PRINT){ dev.off() }

}

# aws scatter lukrecia 
if(0){
  PRINT=1
  
  VAR = c("t2m","ff","dd")
  for( ivar in 1:2 ){
    
    WIDTH=4
    HEIGHT=4
    filename = list(t2m="sup05",ff="sup06")[[VAR[ivar]]]
    #if(PRINT){ pdf(file=paste("T:/cosmoPaper/figures/",filename,".pdf",sep=""), width=WIDTH ,height=HEIGHT) }
    if(PRINT){ png(file=paste("T:/cosmoPaper/figures/",filename,".png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
    #if(PRINT){ png(file=paste("T:/cosmoPaper/seaice/paper/surface_aws_scatter_",VAR[ivar],".png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
    
    COL = c("orange","dodgerblue","forestgreen","firebrick1")
    PTCEX = .1
    PCH = 20
    par(mfrow=c(2,2),omi=c(.0,.05,.15,.1),cex=1,mai=c(.5,.5,0.23,0.2))

    #XLIM = as.POSIXct(c("2016-01-01","2016-12-31"),tz="UTC")
    XLAB = "C15"
    #XAT=seq(XLIM[1],XLIM[2],"2 month"); XmAT=seq(XLIM[1],XLIM[2],"month")
    for( iaws in 1:3 ){
      if(VAR[ivar]=="t2m"){ abcLabel="a)"; YLIM=c(-45,5); YAT=seq(-40,0,20); YmAT=seq(floor(YAT[1]),ceiling(YLIM[2]),10); XLAB = expression(paste("C15 Temperature (C)")); YLAB = expression(paste("AWS Temperature (C)")) }
      if(VAR[ivar]=="ff") { abcLabel="b)"; YLIM=c(0,20); YAT=seq(0,20,10); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),2); XLAB = expression(paste("C15 Wind speed (m s"^"-1",")")); YLAB = expression(paste("AWS Wind speed (m s"^"-1",")")) }
      if(VAR[ivar]=="dd") { abcLabel="c)"; YLIM=c(0,360); YAT=seq(0,360,180); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),90); XLAB = expression(paste("C15 Wind direction ()")); YLAB = expression(paste("AWS Wind direction ()")) }
      XLIM=YLIM
      plot(0,0,col=0,ylab="",xlab="",xlim=XLIM,ylim=YLIM,xaxt="n",yaxt="n",asp=1)
      abline(0,1)
      
      model = data[["C15"]][[iaws]][ data[["C15"]][[iaws]]$time %in% data[["aws"]][[iaws]]$time ]
      aws = data[["aws"]][[iaws]][ data[["aws"]][[iaws]]$time %in% model$time ]
      COLi =  1 + 1 * ( as.POSIXct(c("2016-04-01"),tz="UTC") < aws$time&aws$time < as.POSIXct(c("2016-09-30"),tz="UTC") )
      points(model[[VAR[ivar]]],aws[[VAR[ivar]]],col=COL[COLi],pch=PCH,cex=PTCEX)
      text( par("usr")[1:2]%*%c(.3,.7),par("usr")[3:4]%*%c(.85,.15) ,paste( 
        "Bias =",round(  mean(model[[VAR[ivar]]]-aws[[VAR[ivar]]])  ,1),
        "\nR =",round(  cor(model[[VAR[ivar]]],aws[[VAR[ivar]]])^2  ,2)
      ),cex=0.8
      )
      
      ## axis 1 ##
      axis(1,at=YmAT,tck=-0.02,labels=FALSE)
      axis(1,at=YAT,tck=-0.04,labels=FALSE)
      axis(1,at=YAT,line=-.6,lty=0,las=1)
      mtext(text=XLAB,side=1,line=1.5,cex=1,font=2)
      ## axis 2 ##
      axis(2,at=YmAT,tck=-0.02,labels=FALSE)
      axis(2,at=YAT,tck=-0.04,labels=FALSE)
      axis(2,at=YAT,line=-.6,lty=0,las=2)
      mtext(text=YLAB,side=2,line=1.5,cex=1,font=2)
      ## axis 3 ##
      axis(3,at=YmAT,tck=-0.02,labels=FALSE)
      axis(3,at=YAT,tck=-0.04,labels=FALSE)
      ## axis 4 ##
      axis(4,at=YmAT,tck=-0.02,labels=FALSE)
      axis(4,at=YAT,tck=-0.04,labels=FALSE)
      
      ## a,b,c,d ##
      #text( par("usr")[1:2]%*%c(.98,.02),par("usr")[3:4]%*%c(.1,.9), labels=abcLabel, font=2 )
      text( par("usr")[1:2]%*%c(.7,.3),par("usr")[3:4]%*%c(.1,.9), labels=paste("AWS",iaws), font=2 )
    }
    ## legend ##
    plot(0,0,col=0,ylab="",xlab="",xlim=XLIM,ylim=YLIM,xaxt="n",yaxt="n",xaxs="i",yaxs="i",asp=1,bty="n")
    legend( "center",
            #title=expression(paste("Temperature (C)")),
            legend=c("Summer","Winter"),
            col=COL,pt.cex=1,pch=PCH,bty='n',horiz = FALSE,cex=0.87,xpd=TRUE) 
    
    if(PRINT){ dev.off() }
  }
  
}

# aws3 new 
if(1){
  PRINT=1
  iaws=3
  
  WIDTH=6
  HEIGHT=3
  if(PRINT){ pdf(file=paste("T:/cosmoPaper/figures/fig10.pdf",sep=""), width=WIDTH ,height=HEIGHT) }
  #if(PRINT){ png(file=paste("T:/cosmoPaper/figures/fig10.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  #if(PRINT){ png(file=paste("T:/cosmoPaper/seaice/paper/surface_aws",iaws,".png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  
  COL = c("black","dodgerblue","forestgreen","firebrick1")
  PTCEX = c(1.5,1,1,.5)#(4:1)*.2
  PCH = c(1,3,4,19)
  par(mfrow=c(3,1),omi=c(.0,.1,.0,.1),cex=1)
  VAR = c("t2m","ff","dd")
  XLIM = as.POSIXct(c("2016-01-01","2016-12-31"),tz="UTC")
  XLAB = "month"
  XAT=seq(XLIM[1],XLIM[2],"2 month"); XmAT=seq(XLIM[1],XLIM[2],"month")
  for( ivar in seq(VAR) ){
    if(VAR[ivar]=="t2m"){par(mai=c(0.0,0.5,0.36,0.5)); abcLabel="a)"; YLIM=c(-40,5); YAT=seq(-40,0,20); YmAT=seq(floor(YAT[1]),ceiling(YLIM[2]),10); YLAB = expression(paste("Temperature (C)")) }
    if(VAR[ivar]=="ff") {par(mai=c(0.18,0.5,0.18,0.5)); abcLabel="b)"; YLIM=c(0,7); YAT=seq(0,6,2); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YLAB = expression(paste("Wind speed (m s"^"-1",")")) }
    if(VAR[ivar]=="dd") {par(mai=c(0.36,0.5,0.0,0.5)); abcLabel="c)"; YLIM=c(0,360); YAT=seq(0,360,180); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),90); YLAB = expression(paste("Wind direction ()")) }
    
    plot(0,0,col=0,ylab="",xlab="",xlim=XLIM,ylim=YLIM,xaxt="n",yaxt="n",xaxs="i",yaxs="i")
    
    for(i in seq(mdata)){
      keep = seq(mdata[[i]][[iaws]]$ff)
      #if(VAR[ivar]=="dd"){ keep = data[[i]][[iaws]]$ff>.5 }
      x = mdata[[i]][[iaws]]$time[keep]
      y = mdata[[i]][[iaws]][[VAR[ivar]]][keep]
      points(x,y,col=COL[i],pch=PCH[i],cex=PTCEX[i],lwd=2)
    }
    
    ## axis 1 ##
    axis.POSIXct(1,at=XmAT,tck=-0.04,labels=FALSE)
    if(ivar==3){ 
      axis.POSIXct(1,at=XmAT,tck=-0.04,labels=FALSE)
      axis.POSIXct(1,at=XAT,tck=-0.08,labels=FALSE)
      axis.POSIXct(1,at=XAT,line=-.83,lty=0,labels= month.abb[seq(1,12,2)])
      mtext(text=XLAB,side=1,line=0.8,cex=1) 
    }
    ## axis 2 ##
    axis(2,at=YmAT,tck=-0.04,labels=FALSE)
    axis(2,at=YAT,tck=-0.08,labels=FALSE)
    if(VAR[ivar]!="ff"){
      axis(2,at=YAT,line=-.6,lty=0,las=2)
      mtext(text=YLAB,side=2,line=1.7,cex=1,font=2)
    }
    ## axis 3 ##
    axis.POSIXct(3,at=XmAT,tck=-0.04,labels=FALSE)
    ## axis 4 ##
    axis(4,at=YmAT,tck=-0.04,labels=FALSE)
    axis(4,at=YAT,tck=-0.08,labels=FALSE)
    if(VAR[ivar]=="ff"){
      axis(4,at=YAT,line=-.6,lty=0,las=2)
      mtext(text=YLAB,side=4,line=1.7,cex=1,font=2)
    }
    ## legend ##
    if(ivar==1){ 
      legend( diff(par("usr")[1:2])*.1+par("usr")[1],
              diff(par("usr")[3:4])*.55+par("usr")[4],
              legend=c("AWS 3     ","C15","T15","C05"),
              col=COL,pt.cex=PTCEX,pch=PCH,lwd=2,lty=0,bty='n',horiz = TRUE,cex=0.87,xpd=TRUE) 
    }
    ## a,b,c,d ##
    text( par("usr")[1:2]%*%c(.98,.02),par("usr")[3:4]%*%c(.15,.85), labels=abcLabel, font=2 )
  }
  
  if(PRINT){ dev.off() }
}

# aws3 old
if(0){
  PRINT=1
  iaws=3
  
  WIDTH=6
  HEIGHT=4
  #if(PRINT){ pdf(file=paste("T:/cosmoPaper/seaice/paper/surface_aws",iaws,".pdf",sep=""), width=WIDTH ,height=HEIGHT) }
  if(PRINT){ png(file=paste("T:/cosmoPaper/seaice/paper/surface_aws",iaws,".png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  
  COL = c("black","dodgerblue","forestgreen","firebrick1")
  PTCEX = (4:1)*.2
  PCH = rep(19,4)
  par(mfrow=c(3,1),omi=c(.0,.1,.0,.1),cex=1)
  VAR = c("t2m","ff","dd")
  XLIM = as.POSIXct(c("2016-01-01","2016-12-31"),tz="UTC")
  XLAB = "month"
  XAT=seq(XLIM[1],XLIM[2],"2 month"); XmAT=seq(XLIM[1],XLIM[2],"month")
  for( ivar in seq(VAR) ){
    if(VAR[ivar]=="t2m"){par(mai=c(0.0,0.5,0.4,0.1)); abcLabel="a)"; YLIM=c(-40,5); YAT=seq(-40,0,20); YmAT=seq(floor(YAT[1]),ceiling(YLIM[2]),10); YLAB = expression(paste("Temperature (C)")) }
    if(VAR[ivar]=="ff") {par(mai=c(0.2,0.5,0.2,0.1)); abcLabel="b)"; YLIM=c(0,20); YAT=seq(0,20,10); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),5); YLAB = expression(paste("Wind speed (m s"^"-1",")")) }
    if(VAR[ivar]=="dd") {par(mai=c(0.4,0.5,0.0,0.1)); abcLabel="c)"; YLIM=c(0,360); YAT=seq(0,360,180); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),90); YLAB = expression(paste("Wind direction ()")) }
    
    plot(0,0,col=0,ylab="",xlab="",xlim=XLIM,ylim=YLIM,xaxt="n",yaxt="n",xaxs="i",yaxs="i")
    
    for(i in seq(data)){
      keep = seq(data[[i]][[iaws]]$ff)
      #if(VAR[ivar]=="dd"){ keep = data[[i]][[iaws]]$ff>.5 }
      points(data[[i]][[iaws]]$time[keep],data[[i]][[iaws]][[VAR[ivar]]][keep],col=COL[i],pch=PCH[i],cex=PTCEX[i])
    }
    
    ## axis 1 ##
    axis.POSIXct(1,at=XmAT,tck=-0.02,labels=FALSE)
    if(ivar==3){ 
      axis.POSIXct(1,at=XmAT,tck=-0.02,labels=FALSE)
      axis.POSIXct(1,at=XAT,tck=-0.04,labels=FALSE)
      axis.POSIXct(1,at=XAT,line=-.83,lty=0,labels= month.abb[seq(1,12,2)])
      mtext(text=XLAB,side=1,line=0.8,cex=1) 
    }
    ## axis 2 ##
    axis(2,at=YmAT,tck=-0.02,labels=FALSE)
    axis(2,at=YAT,tck=-0.04,labels=FALSE)
    axis(2,at=YAT,line=-.6,lty=0,las=2)
    mtext(text=YLAB,side=2,line=1.7,cex=0.8,font=2)
    ## axis 3 ##
    axis.POSIXct(3,at=XmAT,tck=-0.02,labels=FALSE)
    ## axis 4 ##
    axis(4,at=YmAT,tck=-0.02,labels=FALSE)
    axis(4,at=YAT,tck=-0.04,labels=FALSE)
    ## legend ##
    if(ivar==1){ 
      legend( diff(par("usr")[1:2])*.2+par("usr")[1],
              diff(par("usr")[3:4])*.45+par("usr")[4],
              legend=c("AWS 3     ","C15","T15","C05"),
              col=COL,pt.cex=PTCEX,pch=PCH,bty='n',horiz = TRUE,cex=0.87,xpd=TRUE) 
    }
    ## a,b,c,d ##
    text( par("usr")[1:2]%*%c(.98,.02),par("usr")[3:4]%*%c(.1,.9), labels=abcLabel, font=2 )
  }
  
  if(PRINT){ dev.off() }
}

# table new
if(0){
  
  for( var in c("t2m","ff") ){
    #name
    TABLE = data.table(name=c("AWS 1","AWS 2","AWS 3"))
    # N
    N = NULL
    for( iaws in 1:3 ){
      N[iaws] = length(data$aws[[iaws]]$time[data$aws[[iaws]]$time<XLIM[2]])
    }
    TABLE$N = N
    #vars
    
    
    for( stat in c("bias","RMSE") ){
      for( ws in c("w","s") ){
        for( RES in c("C15","T15","C05")[1:2] ){
          STAT = NULL
          for( iaws in 1:3 ){
            aws = data$aws[[iaws]]
            sim = data[[RES]][[iaws]] [data[[RES]][[iaws]]$time%in%aws$time]
            aws = aws[ aws$time %in% sim$time]
            
            index = as.numeric(strftime(aws$time,"%m",tz="UTC"))%in%4:9
            if(ws=="s"){ index = !index}
            
            if(stat=="bias"){
              STAT[iaws] = mean( sim[[var]][index] - aws[[var]][index] )
            }else if(stat=="RMSE"){
              STAT[iaws] = sqrt(mean( (sim[[var]][index] - aws[[var]][index])^2 ))
            }
            
          }
          TABLE[[paste(stat,RES,ws,sep="_")]]=round(STAT,1)
        }
      }
    }
    
    write.table(TABLE,file=paste("T:/cosmoPaper/seaice/paper/table_",var,".txt",sep=""),row.names = FALSE,quote=FALSE,sep=" & ",eol=" \\\\\n")
    #write.table(TABLE,file=paste("T:/cosmoPaper/seaice/paper/table_",var,".txt",sep=""),row.names = FALSE,quote=FALSE,sep="\t",eol="\n")
    
  }

}

# table bias
if(0){
  
  #name
  TABLE = data.table(name=c("AWS 1","AWS 2","AWS 3"))
  # N
  N = NULL
  for( iaws in 1:3 ){
    N[iaws] = length(data$aws[[iaws]]$time[data$aws[[iaws]]$time<XLIM[2]])
  }
  TABLE$N = N
  #vars
  
  for( var in c("t2m","ff") ){
    for( ws in c("w","s") ){
      for( RES in c("C15","T15","C05")[1:2] ){
        Bias = NULL
        for( iaws in 1:3 ){
          aws = data$aws[[iaws]]
          sim = data[[RES]][[iaws]] [data[[RES]][[iaws]]$time%in%aws$time]
          aws = aws[ aws$time %in% sim$time]
          
          index = as.numeric(strftime(aws$time,"%m",tz="UTC"))%in%4:9
          if(ws=="s"){ index = !index}
          
          Bias[iaws] = mean( sim[[var]][index] - aws[[var]][index] )
          
        }
        TABLE[[paste(var,RES,ws,sep="_")]]=round(Bias,1)
      }
    }
  }


  write.table(TABLE,file="T:/cosmoPaper/seaice/paper/table.txt",row.names = FALSE,quote=FALSE,sep=" & ",eol=" \\\\\n")
  write.table(TABLE,file="T:/cosmoPaper/seaice/paper/table.txt",row.names = FALSE,quote=FALSE,sep="\t",eol="\n")
  
}

# dd
if(0){
  par(mfrow=c(3,1),omi=c(.9,0,.2,0),mai=c(0,1.5,0,.2),cex=1.5)
  for( i in seq(aws) ){
    
    plot(0,0,col=0,xlab=strftime(XLIM[1],"%Y"),ylab="wind direction ()",xlim=XLIM,ylim=c(-20,36),xaxt="n")
    if(i==3) axis.POSIXct(1,at=seq(XLIM[1],XLIM[2],"month"),format="%b")
    aws[[i]]$dd = (aws[[i]]$RelWndDir + aws[[i]]$Compass)%%360
    lines(aws[[i]]$time,aws[[i]]$dd/10)
    lines(cclm[[i]]$time,cclm[[i]]$dd/10,col="dodgerblue")
    lines(tclm[[i]]$time,tclm[[i]]$dd/10,col="forestgreen")
    
    aa = aws[[i]][ aws[[i]]$time %in% cclm[[i]]$time ] 
    cc = cclm[[i]][ cclm[[i]]$time %in% aa$time ]
    tc = tclm[[i]][ tclm[[i]]$time %in% aa$time ]
    #cc$ff = cc$ff * 0.8
    #tc$ff = tc$ff * 0.8
    diff = cc$dd-aa$dd
    keep = tc$ff*0.825>.5 & aa$WindSp>.5
    diff = diff[keep]
    diff = diff - (diff>180)*360 + (diff< -180)*360
    lines(cc$time[keep],runmed(diff,24*15+1),col="red")
    mtext(paste("bias =",round(mean(diff),1)),3,-1.1, col="dodgerblue",cex=2)
    diff = tc$dd-aa$dd
    keep = tc$ff*0.825>.5 & aa$WindSp>.5
    diff = diff[keep]
    diff = diff - (diff>180)*360 + (diff< -180)*360
    lines(tc$time[keep],runmed(diff,24*15+1),col="purple")
    abline(h=seq(-10,10,5))
    mtext(paste("bias =",round(mean(diff),1)),3,-2.1, col="forestgreen",cex=2)
  }
  #legend("bottomleft",title="2016 sea ice temperature verification",legend=c("automatic weather buoy","C15","T15","15day running median over bias (C15)","15day running median over bias (T15)"),lwd=4,col=c("black","dodgerblue","forestgreen","red","purple"))
}

# ff
if(0){
  par(mfrow=c(3,1),omi=c(.9,0,.2,0),mai=c(0,1.5,0,.2),cex=1.5)
  for( i in seq(aws) ){
    
    plot(0,0,col=0,xlab=strftime(XLIM[1],"%Y"),ylab="wind speed (m/s)",xlim=XLIM,ylim=c(0,15),xaxt="n")
    if(i==3) axis.POSIXct(1,at=seq(XLIM[1],XLIM[2],"month"),format="%b")
    lines(aws[[i]]$time,aws[[i]]$WindSp)
    lines(cclm[[i]]$time,cclm[[i]]$ff,col="dodgerblue")
    lines(tclm[[i]]$time,tclm[[i]]$ff,col="forestgreen")
    
    aa = aws[[i]][ aws[[i]]$time %in% cclm[[i]]$time ] 
    cc = cclm[[i]][ cclm[[i]]$time %in% aa$time ]
    tc = tclm[[i]][ tclm[[i]]$time %in% aa$time ]
    cc$ff = cc$ff * 0.825
    tc$ff = tc$ff * 0.825
    lines(cc$time,runmed(cc$ff-aa$WindSp,24*15+1),col="red")
    lines(tc$time,runmed(tc$ff-aa$WindSp,24*15+1),col="purple")
    # abline(h=c(0,5,10))
    mtext(paste("bias =",round(mean(cc$ff-aa$WindSp),1)),3,-1.1, col="dodgerblue",cex=2)
    mtext(paste("bias =",round(mean(tc$ff-aa$WindSp),1)),3,-2.1, col="forestgreen",cex=2)
  }
  #legend("bottomleft",title="2016 sea ice temperature verification",legend=c("automatic weather buoy","C15","T15","15day running median over bias (C15)","15day running median over bias (T15)"),lwd=4,col=c("black","dodgerblue","forestgreen","red","purple"))
}

# t2m
if(0){
  par(mfrow=c(3,1),omi=c(.9,0,.2,0),mai=c(0,1.5,0,.2),cex=1.5)
  for( i in seq(aws) ){
    
    plot(0,0,col=0,xlab=strftime(XLIM[1],"%Y"),ylab="2m Temperature (C)",xlim=XLIM,ylim=c(-43,5),xaxt="n")
    if(i==3) axis.POSIXct(1,at=seq(XLIM[1],XLIM[2],"month"),format="%b")
    lines(aws[[i]]$time,aws[[i]]$TAir)
    lines(cclm[[i]]$time,cclm[[i]]$t2m,col="dodgerblue")
    lines(tclm[[i]]$time,tclm[[i]]$t2m,col="forestgreen")
    
    aa = aws[[i]][ aws[[i]]$time %in% tclm[[i]]$time ] 
    cc = cclm[[i]][ cclm[[i]]$time %in% aa$time ]
    tc = tclm[[i]][ tclm[[i]]$time %in% aa$time ]
    lines(cc$time,runmed(cc$t2m-aa$TAir,24*15+1),col="red")
    lines(tc$time,runmed(tc$t2m-aa$TAir,24*15+1),col="purple")
    abline(h=c(0,5,10))
    mtext(paste("bias =",round(mean(cc$t2m-aa$TAir),1)),3,-1.1, col="dodgerblue",cex=2)
    mtext(paste("bias =",round(mean(tc$t2m-aa$TAir),1)),3,-2.1, col="forestgreen",cex=2)
  }
  abline(v=seq(as.POSIXct("2016-01-01",tz="UTC"),as.POSIXct("2016-12-31",tz="UTC"),"month"))
  #legend("bottomleft",title="2016 sea ice temperature verification",legend=c("automatic weather buoy","C15","T15","15day running median over bias (C15)","15day running median over bias (T15)"),lwd=4,col=c("black","dodgerblue","forestgreen","red","purple"))
}
