REMOTE = TRUE

library(ncdf4)
library(data.table)
if(REMOTE){
  source("T:/cosmoPaper/map/geo2rot.R")
  source("T:/cosmoPaper/map/rotateWind.R")
  path = "T:/cosmoPaper/surface"
  cclmPath = list( C05="S:/COSMO_", C15="S:/COSMO_" , T15="R:/COSMO_" )
}else{
  source("/home/sida6serv02/zentek/R/ncdf4Utils_1.0/R/geo2rot.R")
  source("/home/sida6serv02/zentek/R/rotateWind.R")
  path="/home/sida6serv02/zentek/cosmoPaper/surface"
  cclmPath = list( C05="/home/sida6serv02/zentek/cosmo/COSMO_" , C15="/home/sida6serv02/zentek/cosmo/COSMO_" , T15="/home/sida6serv02/zentek/cosmo/COSMO_" )
}

load(paste(path,"/rdata/stationOBS.rData",sep=""))

for( RES in c("C05","C15","T15") ){
  load(paste(path,"/rdata/station",RES,".rData",sep=""))
  m = cclm$meta
  if(RES=="C05"){
    station$meta$ix5 = cclm$meta$ix
    station$meta$iy5 = cclm$meta$iy
  }
  if(RES=="C15"){
    station$meta$ix = cclm$meta$ix
    station$meta$iy = cclm$meta$iy
  }
  
  file = paste(cclmPath[[RES]],RES,"_out01/20040404/out01/lffd2004040318c.nc",sep="")
  nc = nc_open(file)
  hsurf = ncvar_get(nc,"HSURF")
  lon = ncvar_get(nc,"lon")
  lat = ncvar_get(nc,"lat")
  rlon = ncvar_get(nc,"rlon")
  rlat = ncvar_get(nc,"rlat")
  nc_close(nc)

  ## correction for southpole ##
  if(RES!="C05"){ lon[261,21]=0 }
  
  windDir = function(u, v){ return( (atan2(u,v)*180/pi + 180)%%360 ) }
  for( is in seq(m$name) ){
    geo = uvrot2geo(cclm$data[[is]]$U_10M,cclm$data[[is]]$V_10M,lon[m$ix[is],m$iy[is]],lat[m$ix[is],m$iy[is]])
    temperatur_korrektur = ( hsurf[ m$ix[is] , m$iy[is] ] - station$meta$height[is] ) /100
    cclm$data[[is]] = data.table(
      time = cclm$data[[is]]$TIME,
      t = cclm$data[[is]]$T_2M - 273.15 + temperatur_korrektur,
      ff = sqrt( cclm$data[[is]]$U_10M^2 + cclm$data[[is]]$V_10M^2 ),
      dd = windDir(geo$u,geo$v),
      ps = cclm$data[[is]]$PS /100,
      pmsl = cclm$data[[is]]$PMSL /100
    )
    
    #print( c( m$height[is] , hsurf[m$ix[is],m$iy[is]] ) )
  }
  
  station[[RES]] = cclm$data
  
}

save(station,file=paste(path,"/rdata/stationFinal.rData",sep=""))



