library(ncdf4)
library(data.table)

# INIT
if(1){
  load(file="T:/cosmoPaper/surface/rdata/statistic.rdata")
}



### plot station stats new
if(0){
  PRINT = 1
  for( dm in c("d","m")){
    VAR = c("t","ff","dd")[]
    for( var in VAR ){
      print(var)
      WIDTH=5
      HEIGHT=4
      filename = list(m=list(t="fig07",ff="fig08",dd="fig09"),d=list(t="sup02",ff="sup03",dd="sup04"))[[dm]][[var]]
      if(PRINT){ pdf(file=paste("T:/cosmoPaper/figures/",filename,".pdf",sep=""), width=WIDTH ,height=HEIGHT) }
      #if(PRINT){ png(file=paste("T:/cosmoPaper/figures/",filename,".png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
      #if(PRINT){ png(file=paste("T:/cosmoPaper/surface/paper/surface_stats_new_",var,"_",dm,".png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
      CEX=0.9
      par(mfrow=c(3,1),omi=rep(.0,4),cex=CEX)
      n = length(STATS[["C15"]]$meta$name)
      XAT=seq(1,n,2); XmAT=seq(n); XLAB="Station number"
      XLIM = c(1-0.5,n+0.5)
      for( rb in c("b","r","c") ){
        if(rb=="b"){ par(mai=c(0.0,0.65,.4,.1)) }
        if(rb=="r"){ par(mai=c(0.15,0.65,.15,.1)) }
        if(rb=="c"){ par(mai=c(0.3,0.65,.0,.1)) }
        if(dm=="d"){
          if(var=="t" & rb=="b"){YLIM=c(-15,15); YAT=seq(-10,10,10); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),5); YYLAB=expression(paste("Temperature (C)")); YLAB="Bias"}
          if(var=="t" & rb=="r"){YLIM=c(0,15); YAT=seq(-15,15,5); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB=expression(paste("Temperature (C)")); YLAB="RMSE"}
          if(var=="t" & rb=="c"){YLIM=c(-1,1); YAT=seq(-1,1,1); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),0.2); YYLAB=expression(paste("Temperature (C)")); YLAB="Corr"}
          if(var=="ff" & rb=="b"){YLIM=c(-11,11); YAT=seq(-10,10,10); YmAT=seq(floor(YAT[1]),ceiling(YLIM[2]),2); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="Bias"}
          if(var=="ff" & rb=="r"){YLIM=c(0,13); YAT=seq(0,10,5); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="RMSE"}
          if(var=="ff" & rb=="c"){YLIM=c(-1,1); YAT=seq(-1,1,1); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),0.2); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="Corr"}
          if(var=="dd" & rb=="b"){YLIM=c(-120,120); YAT=seq(-90,90,90); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),30); YYLAB=expression(paste("Wind direction ()")); YLAB="Bias"}
          if(var=="dd" & rb=="r"){YLIM=c(0,160); YAT=seq(0,180,90); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),30); YYLAB=expression(paste("Wind direction ()")); YLAB="RMSE"}
          if(var=="dd" & rb=="c"){YLIM=c(-1,1); YAT=seq(-1,1,1); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),0.2); YYLAB=expression(paste("Wind direction ()")); YLAB="Corr"}
        }
        if(dm=="m"){
          if(var=="t" & rb=="b"){YLIM=c(-11,11); YAT=seq(-10,10,10); YmAT=seq(floor(YAT[1]),ceiling(YLIM[2]),2); YYLAB=expression(paste("Temperature (C)")); YLAB="Bias"}
          if(var=="t" & rb=="r"){YLIM=c(0,12); YAT=seq(-15,15,5); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB=expression(paste("Temperature (C)")); YLAB="RMSE"}
          if(var=="t" & rb=="c"){YLIM=c(0,1); YAT=seq(-1,1,1); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),0.2); YYLAB=expression(paste("Temperature (C)")); YLAB="Corr"}
          if(var=="ff" & rb=="b"){YLIM=c(-7,7); YAT=seq(-5,5,5); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="Bias"}
          if(var=="ff" & rb=="r"){YLIM=c(0,10); YAT=seq(0,10,5); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="RMSE"}
          if(var=="ff" & rb=="c"){YLIM=c(0,1); YAT=seq(-1,1,1); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),0.2); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="Corr"}
          if(var=="dd" & rb=="b"){YLIM=c(-60,60); YAT=seq(-60,60,60); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),15); YYLAB=expression(paste("Wind direction ()")); YLAB="Bias"}
          if(var=="dd" & rb=="r"){YLIM=c(0,150); YAT=seq(0,180,90); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),30); YYLAB=expression(paste("Wind direction ()")); YLAB="RMSE"}
          if(var=="dd" & rb=="c"){YLIM=c(-0.6,1); YAT=seq(-1,1,1); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),0.2); YYLAB=expression(paste("Wind direction ()")); YLAB="Corr"}
        }

        plot( seq(n) , rep(0,n) , col=0, xlim=XLIM, ylim=YLIM ,xaxt="n",yaxt="n",xlab="",ylab="",xaxs="i",yaxs="i")
        regions = list(1:2,3:5,6:8,9:12,13:18)
        if(rb%in%c("b","c")&YLIM[1]!=0){ abline(h=0,col="gray") }
        abline(v=sapply(regions,min)-0.5)
        for( RES in c("C05","C15","T15") ){
          for( ws in c("s","w") ){
            COLORS = c("firebrick1","dodgerblue","purple","forestgreen","orange")
            hh = 0.15/2
            if(RES=="C05" & ws=="w"){COL=COLORS[1]; offset=-hh*4}
            if(RES=="C15" & ws=="w"){COL=COLORS[2]; offset=-hh*2}
            if(RES=="C15" & ws=="s"){COL=COLORS[3]; offset=0}
            if(RES=="T15" & ws=="w"){COL=COLORS[4]; offset=+hh*2}
            if(RES=="T15" & ws=="s"){COL=COLORS[5]; offset=+hh*4}
            for( is in 1:n ){
              if( (RES=="C05"&ws=="s") | (RES=="C05"&is%in%1:2) ){next}
              data = STATS[[RES]][[is]][[var]][[ws]][[dm]][[rb]]
              Q = as.numeric(quantile(data,c(0.10, 0.25, 0.75, 0.90)))
              rect( is+offset-hh*.99 , Q[2] , is+offset+hh*.99 , Q[3] , col=COL,border=NA, lend=1 )
              lines( rep(is+offset,2) , Q[1:2] , col=COL, lwd=1, lend=1 )
              lines( rep(is+offset,2) , Q[3:4] , col=COL, lwd=1, lend=1 )
              lines( is+offset+c(-hh,hh)*.99 , rep(median(data),2) , lwd=1, lend=1 )
              #points( is+offset , mean(data) , pch=18,cex=.75 )

            }#is
          }#ws
        }#RES
        ## axis 1 ##
        axis(1,at=XmAT,tck=-0.03,labels=FALSE)
        if(rb=="c"){ 
          axis(1,at=XmAT,tck=-0.03,labels=FALSE)
          axis(1,at=XAT,tck=-0.03,labels=FALSE)
          axis(1,at=XAT,line=-.83,lty=0)
          mtext(text=XLAB,side=1,line=0.8,cex=CEX) 
        }
        #axis(1,at=1:n,labels=FALSE)
        #text(1:n, par("usr")[3]-1, labels=STATS[["C15"]]$name, srt=45, adj=1, xpd=TRUE)
        ## axis 2 ##
        axis(2,at=YmAT,tck=-0.02,labels=FALSE)
        axis(2,at=YAT,tck=-0.04,labels=FALSE)
        axis(2,at=YAT,line=-.6,lty=0,las=2)
        if(YLAB=="Corr"&var=="dd"){ YLAB="circ.Corr" }
        mtext(text=YLAB,side=2,line=1.2)
        if(rb=="r"){
          mtext(text=YYLAB,side=2,line=2.1,cex=1.2)#,at=YLIM[2]*1.1 )
        }
        ## axis 3 ##
        axis(3,at=XmAT,tck=-0.03,labels=FALSE)
        if(rb=="b"){ 
          axis(side=3,at= sapply(regions,min)-0.5,lab=FALSE )
          axis(side=3,at= sapply(regions,max)+0.5,lab=FALSE )
          text(sapply(regions,mean), diff(par("usr")[3:4])*.09+par("usr")[4], labels=c("inland","east coast","south pen.","middle pen.","north pen."),xpd=TRUE,cex=0.8)
        }
        ## axis 4 ##
        axis(4,at=YmAT,tck=-0.02,labels=FALSE)
        axis(4,at=YAT,tck=-0.04,labels=FALSE)
        ## legend ##
        if(rb=="b"){ 
          legend( diff(-par("usr")[1:2])*.15+par("usr")[1],
                  diff(par("usr")[3:4])*.45+par("usr")[4],
                  legend=c("C05 winter","C15 winter","C15 summer","T15 winter","T15 summer"),
                  col=COLORS,pch=15,pt.cex=2,bty='n',horiz = TRUE,cex=0.87,xpd=TRUE) 
        }
        ## a,b,c,d ##
        if(rb=="b"){ abcLabel="a)" }
        if(rb=="r"){ abcLabel="b)" }
        if(rb=="c"){ abcLabel="c)" }
        text( par("usr")[1:2]%*%c(.94,.06),par("usr")[3:4]%*%c(.1,.9), labels=abcLabel, font=2 )
      }#rb
      if(PRINT){ dev.off() }
    }#var
  }#dm
  
}

### table
if(0){
  RES="C15"
  file = paste("S:/COSMO_",RES,"_out01/20040404/out01/lffd2004040318c.nc",sep="")
  nc = nc_open(file)
  land = ncvar_get(nc,"FR_LAND")
  hsurf = ncvar_get(nc,"HSURF")
  nc_close(nc)
  RES="C05"
  file = paste("S:/COSMO_",RES,"_out01/20040404/out01/lffd2004040318c.nc",sep="")
  nc = nc_open(file)
  land5 = ncvar_get(nc,"FR_LAND")
  hsurf5 = ncvar_get(nc,"HSURF")
  nc_close(nc)
  
  #ID ok
  TABLE = STATS$meta[,c(1,3,2,4)]
  #name
  #TABLE$name = substr( sub("_"," ",TABLE$name) ,1,5)
  TABLE$name = sub("_"," ",TABLE$name)
  #lon
  TABLE$lon = round(TABLE$lon,3)
  #lat
  TABLE$lat = round(TABLE$lat,3)
  #height ok
  #cosmo height
  TABLE$C05height = round(hsurf5[cbind(STATS$meta$ix5,STATS$meta$iy5)]) #- TABLE$height
  TABLE$C15height = round(hsurf[cbind(STATS$meta$ix,STATS$meta$iy)]) #- TABLE$height
  #cosmo land
  TABLE$C05land = c(" ","yes")[ 1+ land5[cbind(STATS$meta$ix5,STATS$meta$iy5)] ]
  TABLE$C15land = c(" ","yes")[ 1+ land[cbind(STATS$meta$ix,STATS$meta$iy)] ]
  # C05 corrections (outside domain)
  outside = which(STATS$meta$ix5%in%c(1,500)|STATS$meta$iy5%in%c(1,400))
  TABLE$C05height[outside] = TABLE$C05land[outside] = NA
  #aws
  TABLE$aws = unlist(list(bas_surface=" ",bas_aws="yes")[STATS$meta$source])
  #years
  summers=winters=years=NULL
  for(is in seq(TABLE$name)){
    data1 =STATS[["C15"]][[is]][["dd"]][["w"]][["m"]][["c"]]
    data2 =STATS[["C15"]][[is]][["dd"]][["s"]][["m"]][["c"]]
    winters[is] = round(length(c(data1))/6)
    summers[is] = round(length(c(data2))/6)
    years[is] = round(length(c(data1,data2))/12)
  }
#  TABLE$winters=winters
#  TABLE$summers=summers
  TABLE$years=years

  write.table(TABLE,file="T:/cosmoPaper/surface/paper/table.txt",quote=FALSE,sep=" & ",eol=" \\\\\n")
  #write.table(TABLE,file="T:/cosmoPaper/surface/paper/table.txt",quote=FALSE,sep="\t",eol="\n")
  
}

# Halley
if(1){
  # load("T:/cosmoPaper/surface/rdata/stationFinal.rData")
  ID = which(station$meta$name=="Halley")
  PRINT=1
  
  WIDTH=6
  HEIGHT=3
  if(PRINT){ pdf(file=paste("T:/cosmoPaper/figures/fig06.pdf",sep=""), width=WIDTH ,height=HEIGHT) }
  #if(PRINT){ png(file=paste("T:/cosmoPaper/figures/fig06.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  #if(PRINT){ png(file=paste("T:/cosmoPaper/surface/paper/halley.png",sep=""), width=WIDTH*300 ,height=HEIGHT*300,res = 300) }
  
  SRC = c("data","C15","T15")#,"C05")
  COL = c("black","dodgerblue","forestgreen")#,"firebrick1")
  PTCEX = (4:2)*.2
  PCH = rep(19,length(COL))
  par(mfrow=c(3,1),omi=c(.0,.1,.0,.1),cex=1)
  VAR = c("t","ff","dd")
  XLIM = as.POSIXct(c("2016-01-01","2016-01-10"),tz="UTC")
  XLAB = "day"
  XAT=seq(XLIM[1],XLIM[2],"2 day"); XmAT=seq(XLIM[1],XLIM[2],"day")
  for( ivar in seq(VAR) ){
    if(VAR[ivar]=="t")  {par(mai=c(0.0,0.5,0.36,0.5)); abcLabel="a)"; YLIM=c(-20,5); YAT=seq(-40,0,10); YmAT=seq(floor(YAT[1]),ceiling(YLIM[2]),5); YLAB = expression(paste("Temperature (C)")) }
    if(VAR[ivar]=="ff") {par(mai=c(0.18,0.5,0.18,0.5)); abcLabel="b)"; YLIM=c(0,15); YAT=seq(0,20,5); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),5); YLAB = expression(paste("Wind speed (m s"^"-1",")")) }
    if(VAR[ivar]=="dd") {par(mai=c(0.36,0.5,0.0,0.5)); abcLabel="c)"; YLIM=c(0,360); YAT=seq(0,360,180); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),90); YLAB = expression(paste("Wind direction ()")) }
    
    plot(0,0,col=0,ylab="",xlab="",xlim=XLIM,ylim=YLIM,xaxt="n",yaxt="n",xaxs="i",yaxs="i")
    abline(v=seq(XLIM[1],XLIM[2],"day"),col="gray")
    for(i in seq(SRC)){
      data = station[[SRC[i]]][[ID]]
      points(data$time,data[[VAR[ivar]]],col=COL[i],pch=PCH[i],cex=PTCEX[i])
    }
    
    ## axis 1 ##
    axis.POSIXct(1,at=XmAT,tck=-0.04,labels=FALSE)
    if(ivar==3){ 
      axis.POSIXct(1,at=XmAT,tck=-0.04,labels=FALSE)
      axis.POSIXct(1,at=XAT,tck=-0.08,labels=FALSE)
      axis.POSIXct(1,at=XAT,line=-.83,lty=0,format="%d %b")
      mtext(text=XLAB,side=1,line=0.8,cex=1) 
    }
    ## axis 2 ##
    axis(2,at=YmAT,tck=-0.04,labels=FALSE)
    axis(2,at=YAT,tck=-0.08,labels=FALSE)
    if(VAR[ivar]!="ff"){
      axis(2,at=YAT,line=-.6,lty=0,las=2)
      mtext(text=YLAB,side=2,line=1.7,cex=1,font=2)
    }
    ## axis 3 ##
    axis.POSIXct(3,at=XmAT,tck=-0.04,labels=FALSE)
    ## axis 4 ##
    axis(4,at=YmAT,tck=-0.04,labels=FALSE)
    axis(4,at=YAT,tck=-0.08,labels=FALSE)
    if(VAR[ivar]=="ff"){
      axis(4,at=YAT,line=-.6,lty=0,las=2)
      mtext(text=YLAB,side=4,line=1.7,cex=1,font=2)
    }
    ## legend ##
    if(ivar==1){ 
      legend( diff(par("usr")[1:2])*.2+par("usr")[1],
              diff(par("usr")[3:4])*.55+par("usr")[4],
              legend=c("Halley     ","C15","T15"),
              col=COL,pt.cex=PTCEX,pch=PCH,bty='n',horiz = TRUE,cex=0.87,xpd=TRUE) 
    }
    ## a,b,c,d ##
    text( par("usr")[1:2]%*%c(.98,.02),par("usr")[3:4]%*%c(.15,.85), labels=abcLabel, font=2 )
  }
  
  if(PRINT){ dev.off() }
}

### plot station stats old
if(0){
  PRINT = 1
  VAR = c("t","ff","dd")
  for( var in VAR ){
    if(PRINT){ pdf(file=paste("T:/cosmoPaper/surface/paper/surface_stats_",var,".pdf",sep=""), width=5 ,height=3) }
    CEX=0.9
    par(mfrow=c(2,1),omi=rep(.0,4),cex=CEX)
    n = length(STATS[["C15"]]$name)
    XAT=seq(1,n,2); XmAT=seq(n); XLAB="Station number"
    XLIM = c(1-0.5,n+0.5)
    for( rb in c("b","r") ){
      if(rb=="b"){ par(mai=c(0.0,0.65,.4,.1)) }
      if(rb=="r"){ par(mai=c(0.3,0.65,.1,.1)) }
      if(var=="t" & rb=="r"){YLIM=c(0,10); YAT=seq(-4,8,4); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB="Temperature (C)"; YLAB="RMSE"}
      if(var=="t" & rb=="b"){YLIM=c(-6,9); YAT=seq(-4,8,4); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB="Temperature (C)"; YLAB="bias"}
      if(var=="ff" & rb=="r"){YLIM=c(0,10); YAT=seq(0,8,4); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="RMSE"}
      if(var=="ff" & rb=="b"){YLIM=c(-4,2); YAT=seq(-4,2,2); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),1); YYLAB=expression(paste("Wind speed (m s"^"-1",")")); YLAB="bias"}
      if(var=="dd" & rb=="r"){YLIM=c(0,100); YAT=seq(0,90,45); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),15); YYLAB="Wind direction ()"; YLAB="RMSE"}
      if(var=="dd" & rb=="b"){YLIM=c(-45,30); YAT=seq(-30,30,30); YmAT=seq(floor(YLIM[1]),ceiling(YLIM[2]),15); YYLAB="Wind direction ()"; YLAB="bias"}
      plot( seq(n) , rep(0,n) , col=0, xlim=XLIM, ylim=YLIM ,xaxt="n",yaxt="n",xlab="",ylab="",xaxs="i",yaxs="i")
      regions = list(1:2,3:5,6:8,9:12,13:18)
      abline(h=0)
      abline(v=sapply(regions,min)-0.5)
      for( RES in c("C15","T15")[1:2] ){
        for( ws in c("s","w") ){
          COLORS = c("dodgerblue3","dodgerblue","forestgreen","green3")
          if(RES=="C15" & ws=="w"){COL=COLORS[1]; offset=-0.3}
          if(RES=="C15" & ws=="s"){COL=COLORS[2]; offset=-0.1}
          if(RES=="T15" & ws=="w"){COL=COLORS[3];offset=+0.1}
          if(RES=="T15" & ws=="s"){COL=COLORS[4];offset=+0.3}
          for( index in regions){
            #lines(index+offset,STATS[[RES]][[paste(var,"_",ws,rb,sep="")]][index],type="h",lend=1,lwd=4,col=COL)
            for( is in 1:n ){
              rect( is+offset-0.1 , 0 , is+offset+0.1 , STATS[[RES]][[paste(var,"_",ws,rb,sep="")]][is] , col=COL )
            }
          }
        }#ws
      }#RES
      ## axis 1 ##
      axis(1,at=XmAT,tck=0.03,labels=FALSE)
      if(rb=="r"){ 
        axis(1,at=XmAT,tck=-0.03,labels=FALSE)
        axis(1,at=XAT,tck=-0.03,labels=FALSE)
        axis(1,at=XAT,line=-.83,lty=0)
        mtext(text=XLAB,side=1,line=0.8,cex=CEX) 
      }
      #axis(1,at=1:n,labels=FALSE)
      #text(1:n, par("usr")[3]-1, labels=STATS[["C15"]]$name, srt=45, adj=1, xpd=TRUE)
      ## axis 2 ##
      axis(2,at=YmAT,tck=-0.02,labels=FALSE)
      axis(2,at=YAT,tck=-0.04,labels=FALSE)
      axis(2,at=YAT,line=-.6,lty=0)
      mtext(text=YLAB,side=2,line=1.2)
      if(rb=="r"){
        mtext(text=YYLAB,side=2,line=2.2,at=YLIM[2]*1.1 )
      }
      ## axis 3 ##
      axis(3,at=XmAT,tck=0.03,labels=FALSE)
      if(rb=="b"){ 
        axis(side=3,at= sapply(regions,min)-0.5,lab=FALSE )
        axis(side=3,at= sapply(regions,max)+0.5,lab=FALSE )
        text(sapply(regions,mean), diff(par("usr")[3:4])*.07+par("usr")[4], labels=c("inland","east coast","south pen.","middle pen.","north pen."),xpd=TRUE,cex=0.8)
      }
      ## axis 4 ##
      axis(4,at=YmAT,tck=-0.02,labels=FALSE)
      axis(4,at=YAT,tck=-0.04,labels=FALSE)
      ## legend ##
      if(rb=="b"){ 
        legend( diff(-par("usr")[1:2])*.1+par("usr")[1],
                diff(par("usr")[3:4])*.40+par("usr")[4],
                legend=c("C15 winter","C15 summer","T15 winter","T15 summer"),
                col=COLORS,pch=15,pt.cex=2,bty='n',horiz = TRUE,cex=1,xpd=TRUE) 
      }
      ## a,b,c,d ##
      if(rb=="b"){ abcLabel="a)" }
      if(rb=="r"){ abcLabel="b)" }
      text( par("usr")[1:2]%*%c(.95,.05),par("usr")[3:4]%*%c(.1,.90), labels=abcLabel, font=2 )
    }#rb
    if(PRINT){ dev.off() }
  }#var
  
}

### plot station stats very old
if(0){
  VAR = c("t","ff","dd")
  for( var in VAR[1] ){
    if(var=="t"){YLIM=c(-35,5)}
    if(var=="ff"){YLIM=c(-5,5)}
    if(var=="dd"){YLIM=c(-55,55)}
    par(mfrow=c(2,1),omi=rep(.5,4),mai=rep(0,4))
    n = length(STATS[["C15"]]$name)
    for( ws in c("s","w") ){
      plot( seq(n) , rep(0,n) , col=0, ylim=YLIM ,xaxt="n" )
      abline(h=0)
      for( RES in c("C15","T15")[1:2] ){
        for( rb in c("r","b")[2] ){
          if(RES=="C15"){COL="dodgerblue"}
          if(RES=="T15"){COL="forestgreen"}
          for( index in list(1:2,3:5,6:8,9:13,14:19) ){
            lines(index,STATS[[RES]][[paste(var,"_",ws,rb,sep="")]][index],type="b",pch=19,lwd=5,col=COL)
          }
        }#rb
      }#RES
    }#ws
  }#var
}